Index: rtp.c
===================================================================
--- rtp.c	(revision 48582)
+++ rtp.c	(working copy)
@@ -268,6 +268,7 @@
 	unsigned int duration;
 	char resp = 0;
 	struct ast_frame *f = NULL;
+
 	event = ntohl(*((unsigned int *)(data)));
 	event >>= 24;
 	event_end = ntohl(*((unsigned int *)(data)));
@@ -275,8 +276,10 @@
 	event_end >>= 24;
 	duration = ntohl(*((unsigned int *)(data)));
 	duration &= 0xFFFF;
+
 	if (rtpdebug)
 		ast_log(LOG_DEBUG, "- RTP 2833 Event: %08x (len = %d)\n", event, len);
+
 	if (event < 10) {
 		resp = '0' + event;
 	} else if (event < 11) {
@@ -288,25 +291,16 @@
 	} else if (event < 17) {	/* Event 16: Hook flash */
 		resp = 'X';	
 	}
-	if (rtp->resp && (rtp->resp != resp)) {
+
+	/* If this is a new end packet, then queue a new DTMF */
+	if ((event_end & 0x80) && (rtp->lasteventendseqn != seqno) && (rtp->resp != resp)) {
+		rtp->resp = resp;
+		rtp->lasteventendseqn = seqno;
+		rtp->dtmfcount = dtmftimeout;
+		rtp->dtmfduration = duration;
 		f = send_dtmf(rtp);
-	} else if(event_end & 0x80) {
-		if (rtp->resp) {
-			if(rtp->lasteventendseqn != seqno) {
-				f = send_dtmf(rtp);
-				rtp->lasteventendseqn = seqno;
-			}
-			rtp->resp = 0;
-		}
-		resp = 0;
-		duration = 0;
-	} else if (rtp->resp && rtp->dtmfduration && (duration < rtp->dtmfduration)) {
-		f = send_dtmf(rtp);
 	}
-	if (!(event_end & 0x80))
-		rtp->resp = resp;
-	rtp->dtmfcount = dtmftimeout;
-	rtp->dtmfduration = duration;
+
 	return f;
 }
 
@@ -545,15 +539,12 @@
 				duration &= 0xFFFF;
 				ast_verbose("Got rfc2833 RTP packet from %s:%d (type %d, seq %d, ts %d, len %d, mark %d, event %08x, end %d, duration %d) \n", ast_inet_ntoa(iabuf, sizeof(iabuf), sin.sin_addr), ntohs(sin.sin_port), payloadtype, seqno, timestamp, res - hdrlen, (mark?1:0), event, ((event_end & 0x80)?1:0), duration);
 			}
-			if (rtp->lasteventseqn <= seqno || rtp->resp == 0 || (rtp->lasteventseqn >= 65530 && seqno <= 6)) {
-				f = process_rfc2833(rtp, rtp->rawdata + AST_FRIENDLY_OFFSET + hdrlen, res - hdrlen, seqno);
+			if ((f = process_rfc2833(rtp, rtp->rawdata + AST_FRIENDLY_OFFSET + hdrlen, res - hdrlen, seqno))) {
 				rtp->lasteventseqn = seqno;
-			} else
-				f = NULL;
-			if (f)
 				return f;
-			else
+			} else {
 				return &null_frame;
+			}
 		} else if (rtpPT.code == AST_RTP_CISCO_DTMF) {
 			/* It's really special -- process it the Cisco way */
 			if (rtp->lasteventseqn <= seqno || rtp->resp == 0 || (rtp->lasteventseqn >= 65530 && seqno <= 6)) {
